library rwa_mix_wig;
import 'dart:io';
import 'package:flutter/material.dart';
import 'package:flutter/rendering.dart';

import 'dart:ui' as ui;
import 'package:path_provider/path_provider.dart';

/// A Calculator.
class MixWig extends StatefulWidget {
  final Widget? base;
  final Widget? second;
  MixWig({this.base,this.second,});
  // This widget is the root of your application.
  @override
  _MixWigState createState() => _MixWigState();
}
class _MixWigState extends State<MixWig> {
  double offSetX = 200.0;
  double offSetY = 200.0;
  bool isChildIsSelected = false;
  double previousScale = 1.0;
  double newScale = 1.0;
  String fileName = '';
  GlobalKey globalKey = GlobalKey();
  Widget? base;
  Widget? second;

  @override
  void initState() {
    // TODO: implement initState
    if(widget.base == null){
      base = Card(
        child: Container(
          height: 400,
          width: double.infinity,
          color: Colors.blue,
        ),
      );
    }
    if(widget.second == null){
      second = Card(
        child: Container(
          height: 400,
          width: double.infinity,
          color: Colors.blue,
        ),
      );
    }
    super.initState();
  }
  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      title: 'Flutter Demo',
      theme: ThemeData(
        // This is the theme of your application.
        //
        // Try running your application with "flutter run". You'll see the
        // application has a blue toolbar. Then, without quitting the app, try
        // changing the primarySwatch below to Colors.green and then invoke
        // "hot reload" (press "r" in the console where you ran "flutter run",
        // or simply save your changes to "hot reload" in a Flutter IDE).
        // Notice that the counter didn't reset back to zero; the application
        // is not restarted.
        primarySwatch: Colors.blue,
      ),
      home: Scaffold(
        body: Column(
          children: [
            _ConvertWidgetToImage(
              key: globalKey,
              builder: (key) =>Stack(
                children: [
                  GestureDetector(
                    onScaleStart: (data) {
                      if (isChildIsSelected) {
                        previousScale = newScale;
                      }
                      setState(() {

                      });
                    },
                    onScaleUpdate: (data) {
                      if (isChildIsSelected) {
                        newScale = data.scale;
                      }
                      setState(() {

                      });
                    },
                    onHorizontalDragStart: (data) {
                      if (!isChildIsSelected) {
                        offSetX = data.globalPosition.dx;
                        offSetY = data.globalPosition.dy;
                      }
                      setState(() {

                      });
                    },
                    onHorizontalDragUpdate: (data) {
                      if (!isChildIsSelected) {
                        offSetX = data.globalPosition.dx;
                        offSetY = data.globalPosition.dy;
                      }
                      setState(() {

                      });
                    },
                    child: Card(
                      child: base,
                    ),
                  ),
                  Positioned(
                    left: offSetX -( 85)*newScale,
                    top: offSetY -( 85)*newScale,
                    child: GestureDetector(
                      onTap: () {
                        isChildIsSelected = !isChildIsSelected;
                        setState(() {

                        });
                      },
                      child: Container(
                        color: Colors.transparent,
                        child: Column(
                          children: [
                            Container(
                              decoration: BoxDecoration(
                                  shape: BoxShape.circle,
                                  color: isChildIsSelected
                                      ? Colors.white54
                                      : Colors.transparent),
                              height: 110 * newScale,
                              width: 110 * newScale,
                              alignment: Alignment.center,
                              child: Container(
                                decoration: BoxDecoration(
                                    shape: BoxShape.circle, color: Colors.transparent),
                                height: 90 * newScale,
                                width: 90 * newScale,
                                child: second,
                              ),
                            )
                          ],
                        ),
                      ),
                    ),
                  ),
                ],
              ),
            ),
          ],
        ),
      ),
    );
  }
}
Future capture(GlobalKey key) async {


  RenderRepaintBoundary? boundary = key.currentContext!.findRenderObject() as RenderRepaintBoundary?;
  final image = await boundary!.toImage(pixelRatio: 3);
  final byteData = await image.toByteData(format: ui.ImageByteFormat.png);
  final pngBytes = byteData!.buffer.asUint8List();

  final directory = await getApplicationDocumentsDirectory();
  final pathOfImage = await File('${directory.path}/user_avatar.png').create();
  await pathOfImage.writeAsBytes(pngBytes);
  return pathOfImage; }
class _ConvertWidgetToImage extends StatefulWidget {
  final Function(GlobalKey key) builder;

  const _ConvertWidgetToImage({
    required this.builder,
    required Key key,
  }) : super(key: key);

  @override
  _ConvertWidgetToImageState createState() => _ConvertWidgetToImageState();
}
class _ConvertWidgetToImageState extends State<_ConvertWidgetToImage> {
  final globalKey = GlobalKey();

  @override
  Widget build(BuildContext context) {
    return RepaintBoundary(
      key: globalKey,
      child: widget.builder(globalKey),
    );
  }
}
